> For the complete documentation index, see [llms.txt](https://docs.poshtools.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.poshtools.com/powershell-pro-tools-documentation/installation-and-configuration/visual-studio-offline-installation.md).

# Visual Studio Offline Installation

You can accomplish offline installation by following the [Visual Studio offline installation instructions](https://docs.microsoft.com/en-us/visualstudio/install/create-an-offline-installation-of-visual-studio?view=vs-2019#use-the-command-line-to-create-a-local-cache).&#x20;

Download the Visual Studio Edition of choice and run the following command line.&#x20;

```
 vs_community.exe --layout c:\vslayout --add Microsoft.VisualStudio.Workload.ManagedDesktop --add Microsoft.VisualStudio.Workload.NetWeb --add Component.GitHub.VisualStudio --includeOptional --lang en-US
```

You will now need to [download the PowerShell Tools VSIX](https://marketplace.visualstudio.com/items?itemName=AdamRDriscoll.PowerShellToolsforVisualStudio2017-18561) file from the Visual Studio Marketplace.&#x20;

On a machine with an internet connection, double click the VSIX file.

![](/files/-M-MJQoJ6wGpODQ3Dke2)

The online machine will install the certificate to the local machine.  After the VSIX installer opens, click the Digital Signature link to view more information about the certificate. Click Install Certificate.

![](/files/-M-MKnWURAR--89mN0p2)

Next, you'll want to export the certificate to a file. Use certmgr.msc to export the certificate.

![](/files/-M-MKwxlroLahwcElMVc)

Ensure you export all the certificates in the certificate path. &#x20;

![](/files/-M-MNPwRyrXCvWhue7Yb)

Move the P7B file to the offline machine along with the PowerShell Tools VSIX file. Install the certificate to the certificate store.&#x20;

After creating the offline installation layout, you can then move the `vslayout` folder to an offline location.  Within the certificates folder within `vslayout` folder, you may need to [install all the certificates ](https://docs.microsoft.com/en-us/visualstudio/install/install-certificates-for-visual-studio-offline?view=vs-2019)in order to correctly install the package.&#x20;

Run the offline installation using the following command line.

```
C:\vslayout\vs_community.exe --add Microsoft.VisualStudio.Workload.ManagedDesktop --add Microsoft.VisualStudio.Workload.NetWeb --add Component.GitHub.VisualStudio --includeOptional
```

Finally, double click the PowerShell Tools VSIX to install PowerShell Tools for Visual Studio.&#x20;


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.poshtools.com/powershell-pro-tools-documentation/installation-and-configuration/visual-studio-offline-installation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
